<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:07 +0000">

<link rel="stylesheet" type="text/css" href="../../../stylesheet.css">
<link rel="start" href="../../../overview-summary.html">

<title>doclets/standard/classWriter.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../../overview-files.html">Files</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../todo-list.html">Todo</a></li>
<li><a href="../../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../../index.html" target="_top">Frames</a>
<a href="../../../source/doclets/standard/classwriter.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>doclets/standard/classWriter.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2004 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** This generates the HTML API documentation for each individual interface
<a name="line22"></a> * and class.
<a name="line23"></a> *
<a name="line24"></a> * @package PHPDoctor\Doclets\Standard
<a name="line25"></a> */
<a name="line26"></a>class ClassWriter extends HTMLWriter
<a name="line27"></a>{
<a name="line28"></a>
<a name="line29"></a>	/** Build the class definitons.
<a name="line30"></a>	 *
<a name="line31"></a>	 * @param Doclet doclet
<a name="line32"></a>	 */
<a name="line33"></a>	function classWriter(&$doclet)
<a name="line34"></a>    {
<a name="line35"></a>	
<a name="line36"></a>		parent::HTMLWriter($doclet);
<a name="line37"></a>		
<a name="line38"></a>		$this->_id = 'definition';
<a name="line39"></a>
<a name="line40"></a>		$rootDoc =& $this->_doclet->rootDoc();
<a name="line41"></a>		$phpdoctor =& $this->_doclet->phpdoctor();
<a name="line42"></a>		
<a name="line43"></a>		$packages =& $rootDoc->packages();
<a name="line44"></a>        ksort($packages);
<a name="line45"></a>
<a name="line46"></a>		foreach ($packages as $packageName => $package) {
<a name="line47"></a>
<a name="line48"></a>			$this->_sections[0] = array('title' => 'Overview', 'url' => 'overview-summary.html');
<a name="line49"></a>			$this->_sections[1] = array('title' => 'Namespace', 'url' => $package->asPath().'/package-summary.html');
<a name="line50"></a>			$this->_sections[2] = array('title' => 'Class', 'selected' => TRUE);
<a name="line51"></a>			//$this->_sections[3] = array('title' => 'Use');
<a name="line52"></a>			if ($phpdoctor->getOption('tree')) $this->_sections[4] = array('title' => 'Tree', 'url' => $package->asPath().'/package-tree.html');
<a name="line53"></a>			if ($doclet->includeSource()) $this->_sections[5] = array('title' => 'Files', 'url' => 'overview-files.html');
<a name="line54"></a>			$this->_sections[6] = array('title' => 'Deprecated', 'url' => 'deprecated-list.html');
<a name="line55"></a>			$this->_sections[7] = array('title' => 'Todo', 'url' => 'todo-list.html');
<a name="line56"></a>			$this->_sections[8] = array('title' => 'Index', 'url' => 'index-all.html');
<a name="line57"></a>			
<a name="line58"></a>			$this->_depth = $package->depth() + 1;
<a name="line59"></a>			
<a name="line60"></a>			$classes =& $package->allClasses();
<a name="line61"></a>			
<a name="line62"></a>			if ($classes) {
<a name="line63"></a>                ksort($classes);
<a name="line64"></a>				foreach ($classes as $name => $class) {
<a name="line65"></a>					
<a name="line66"></a>					ob_start();
<a name="line67"></a>					
<a name="line68"></a>					echo "<hr>\n\n";
<a name="line69"></a>					
<a name="line70"></a>					echo '<div class="qualifiedName">', $class->qualifiedName(), "</div>\n";
<a name="line71"></a>					$this->_sourceLocation($class);
<a name="line72"></a>					
<a name="line73"></a>					if ($class->isInterface()) {
<a name="line74"></a>						echo '<h1>Interface ', $class->name(), "</h1>\n\n";
<a name="line75"></a>					} else {
<a name="line76"></a>						echo '<h1>Class ', $class->name(), "</h1>\n\n";
<a name="line77"></a>					}
<a name="line78"></a>					
<a name="line79"></a>					echo '<pre class="tree">';
<a name="line80"></a>					$result = $this->_buildTree($rootDoc, $classes[$name]);
<a name="line81"></a>					echo $result[0];
<a name="line82"></a>					echo "</pre>\n\n";
<a name="line83"></a>					
<a name="line84"></a>					$implements =& $class->interfaces();
<a name="line85"></a>					if (count($implements) > 0) {
<a name="line86"></a>						echo "<dl>\n";
<a name="line87"></a>						echo "<dt>All Implemented Interfaces:</dt>\n";
<a name="line88"></a>						echo '<dd>';
<a name="line89"></a>						foreach ($implements as $interface) {
<a name="line90"></a>						    echo '<a href="', str_repeat('../', $this->_depth), $interface->asPath(), '">';
<a name="line91"></a>						    if ($interface->packageName() != $class->packageName()) {
<a name="line92"></a>						        echo $interface->packageName(), '\\';
<a name="line93"></a>						    }
<a name="line94"></a>						    echo $interface->name(), '</a> ';
<a name="line95"></a>						}
<a name="line96"></a>						echo "</dd>\n";
<a name="line97"></a>						echo "</dl>\n\n";
<a name="line98"></a>					}
<a name="line99"></a>					
<a name="line100"></a>					echo "<hr>\n\n";
<a name="line101"></a>					
<a name="line102"></a>					if ($class->isInterface()) {
<a name="line103"></a>						echo '<p class="signature">', $class->modifiers(), ' interface <strong>', $class->name(), '</strong>';
<a name="line104"></a>					} else {
<a name="line105"></a>						echo '<p class="signature">', $class->modifiers(), ' class <strong>', $class->name(), '</strong>';
<a name="line106"></a>					}
<a name="line107"></a>					if ($class->superclass()) {
<a name="line108"></a>						$superclass =& $rootDoc->classNamed($class->superclass());
<a name="line109"></a>						if ($superclass) {
<a name="line110"></a>							echo '<br>extends <a href="', str_repeat('../', $this->_depth), $superclass->asPath(), '">', $superclass->name(), "</a>\n\n";
<a name="line111"></a>						} else {
<a name="line112"></a>							echo '<br>extends ', $class->superclass(), "\n\n";
<a name="line113"></a>						}
<a name="line114"></a>					}
<a name="line115"></a>					echo "</p>\n\n";
<a name="line116"></a>					
<a name="line117"></a>					$textTag =& $class->tags('@text');
<a name="line118"></a>					if ($textTag) {
<a name="line119"></a>						echo '<div class="comment" id="overview_description">', $this->_processInlineTags($textTag), "</div>\n\n";
<a name="line120"></a>					}
<a name="line121"></a>
<a name="line122"></a>					$this->_processTags($class->tags());
<a name="line123"></a>
<a name="line124"></a>					echo "<hr>\n\n";
<a name="line125"></a>
<a name="line126"></a>					$constants =& $class->constants();
<a name="line127"></a>                    ksort($constants);
<a name="line128"></a>					$fields =& $class->fields();
<a name="line129"></a>                    ksort($fields);
<a name="line130"></a>					$methods =& $class->methods();
<a name="line131"></a>                    ksort($methods);
<a name="line132"></a>
<a name="line133"></a>					if ($constants) {
<a name="line134"></a>						echo '<table id="summary_field">', "\n";
<a name="line135"></a>						echo '<tr><th colspan="2">Constant Summary</th></tr>', "\n";
<a name="line136"></a>						foreach ($constants as $field) {
<a name="line137"></a>							$textTag =& $field->tags('@text');
<a name="line138"></a>							echo "<tr>\n";
<a name="line139"></a>							echo '<td class="type">', $field->modifiers(FALSE), ' ', $field->typeAsString(), "</td>\n";
<a name="line140"></a>							echo '<td class="description">';
<a name="line141"></a>							echo '<p class="name"><a href="#', $field->name(), '">';
<a name="line142"></a>							if (is_null($field->constantValue())) echo '$';
<a name="line143"></a>							echo $field->name(), '</a></p>';
<a name="line144"></a>							if ($textTag) {
<a name="line145"></a>								echo '<p class="description">', strip_tags($this->_processInlineTags($textTag, TRUE), '<a><b><strong><u><em>'), '</p>';
<a name="line146"></a>							}
<a name="line147"></a>							echo "</td>\n";
<a name="line148"></a>							echo "</tr>\n";
<a name="line149"></a>						}
<a name="line150"></a>						echo "</table>\n\n";
<a name="line151"></a>					}
<a name="line152"></a>					
<a name="line153"></a>					if ($fields) {
<a name="line154"></a>						echo '<table id="summary_field">', "\n";
<a name="line155"></a>						echo '<tr><th colspan="2">Field Summary</th></tr>', "\n";
<a name="line156"></a>						foreach ($fields as $field) {
<a name="line157"></a>							$textTag =& $field->tags('@text');
<a name="line158"></a>							echo "<tr>\n";
<a name="line159"></a>							echo '<td class="type">', $field->modifiers(FALSE), ' ', $field->typeAsString(), "</td>\n";
<a name="line160"></a>							echo '<td class="description">';
<a name="line161"></a>							echo '<p class="name"><a href="#', $field->name(), '">';
<a name="line162"></a>							if (is_null($field->constantValue())) echo '$';
<a name="line163"></a>							echo $field->name(), '</a></p>';
<a name="line164"></a>							if ($textTag) {
<a name="line165"></a>								echo '<p class="description">', strip_tags($this->_processInlineTags($textTag, TRUE), '<a><b><strong><u><em>'), '</p>';
<a name="line166"></a>							}
<a name="line167"></a>							echo "</td>\n";
<a name="line168"></a>							echo "</tr>\n";
<a name="line169"></a>						}
<a name="line170"></a>						echo "</table>\n\n";
<a name="line171"></a>					}
<a name="line172"></a>					
<a name="line173"></a>					if ($class->superclass()) {
<a name="line174"></a>                        $superclass =& $rootDoc->classNamed($class->superclass());
<a name="line175"></a>                        if ($superclass) {
<a name="line176"></a>                            $this->inheritFields($superclass, $rootDoc, $package);
<a name="line177"></a>                        }
<a name="line178"></a>					}
<a name="line179"></a>
<a name="line180"></a>					if ($methods) {
<a name="line181"></a>						echo '<table id="summary_method">', "\n";
<a name="line182"></a>						echo '<tr><th colspan="2">Method Summary</th></tr>', "\n";
<a name="line183"></a>                        foreach($methods as $method) {
<a name="line184"></a>                            $textTag =& $method->tags('@text');
<a name="line185"></a>                            echo "<tr>\n";
<a name="line186"></a>                            echo '<td class="type">', $method->modifiers(FALSE), ' ', $method->returnTypeAsString(), "</td>\n";
<a name="line187"></a>                            echo '<td class="description">';
<a name="line188"></a>                            echo '<p class="name"><a href="#', $method->name(), '()">', $method->name(), '</a>', $method->flatSignature(), '</p>';
<a name="line189"></a>                            if ($textTag) {
<a name="line190"></a>                                echo '<p class="description">', strip_tags($this->_processInlineTags($textTag, TRUE), '<a><b><strong><u><em>'), '</p>';
<a name="line191"></a>                            }
<a name="line192"></a>                            echo "</td>\n";
<a name="line193"></a>                            echo "</tr>\n";
<a name="line194"></a>                        }
<a name="line195"></a>						echo "</table>\n\n";
<a name="line196"></a>					}
<a name="line197"></a>					
<a name="line198"></a>					if ($class->superclass()) {
<a name="line199"></a>                        $superclass =& $rootDoc->classNamed($class->superclass());
<a name="line200"></a>                        if ($superclass) {
<a name="line201"></a>                            $this->inheritMethods($superclass, $rootDoc, $package);
<a name="line202"></a>                        }
<a name="line203"></a>					}
<a name="line204"></a>
<a name="line205"></a>					if ($constants) {
<a name="line206"></a>						echo '<h2 id="detail_field">Constant Detail</h2>', "\n";
<a name="line207"></a>						foreach($constants as $field) {
<a name="line208"></a>							$textTag =& $field->tags('@text');
<a name="line209"></a>							$type =& $field->type();
<a name="line210"></a>							$this->_sourceLocation($field);
<a name="line211"></a>							echo '<h3 id="', $field->name(),'">', $field->name(), "</h3>\n";
<a name="line212"></a>							echo '<code class="signature">', $field->modifiers(), ' ', $field->typeAsString(), ' <strong>';
<a name="line213"></a>							if (is_null($field->constantValue())) echo '$';
<a name="line214"></a>							echo $field->name(), '</strong>';
<a name="line215"></a>							if (!is_null($field->value())) echo ' = ', htmlspecialchars($field->value());
<a name="line216"></a>							echo "</code>\n";
<a name="line217"></a>                            echo '<div class="details">', "\n";
<a name="line218"></a>							if ($textTag) {
<a name="line219"></a>								echo $this->_processInlineTags($textTag);
<a name="line220"></a>							}
<a name="line221"></a>							$this->_processTags($field->tags());
<a name="line222"></a>                            echo "</div>\n\n";
<a name="line223"></a>							echo "<hr>\n\n";
<a name="line224"></a>						}
<a name="line225"></a>					}
<a name="line226"></a>
<a name="line227"></a>					if ($fields) {
<a name="line228"></a>						echo '<h2 id="detail_field">Field Detail</h2>', "\n";
<a name="line229"></a>						foreach($fields as $field) {
<a name="line230"></a>							$textTag =& $field->tags('@text');
<a name="line231"></a>							$type =& $field->type();
<a name="line232"></a>							$this->_sourceLocation($field);
<a name="line233"></a>							echo '<h3 id="', $field->name(),'">', $field->name(), "</h3>\n";
<a name="line234"></a>							echo '<code class="signature">', $field->modifiers(), ' ', $field->typeAsString(), ' <strong>';
<a name="line235"></a>							if (is_null($field->constantValue())) echo '$';
<a name="line236"></a>							echo $field->name(), '</strong>';
<a name="line237"></a>							if (!is_null($field->value())) echo ' = ', htmlspecialchars($field->value());
<a name="line238"></a>							echo "</code>\n";
<a name="line239"></a>                            echo '<div class="details">', "\n";
<a name="line240"></a>							if ($textTag) {
<a name="line241"></a>								echo $this->_processInlineTags($textTag);
<a name="line242"></a>							}
<a name="line243"></a>							$this->_processTags($field->tags());
<a name="line244"></a>                            echo "</div>\n\n";
<a name="line245"></a>							echo "<hr>\n\n";
<a name="line246"></a>						}
<a name="line247"></a>					}
<a name="line248"></a>					
<a name="line249"></a>					if ($methods) {
<a name="line250"></a>						echo '<h2 id="detail_method">Method Detail</h2>', "\n";
<a name="line251"></a>                        foreach($methods as $method) {
<a name="line252"></a>                            $textTag =& $method->tags('@text');
<a name="line253"></a>                            $this->_sourceLocation($method);
<a name="line254"></a>                            echo '<h3 id="', $method->name(),'()">', $method->name(), "</h3>\n";
<a name="line255"></a>                            echo '<code class="signature">', $method->modifiers(), ' ', $method->returnTypeAsString(), ' <strong>';
<a name="line256"></a>                            echo $method->name(), '</strong>', $method->flatSignature();
<a name="line257"></a>                            echo "</code>\n";
<a name="line258"></a>                            echo '<div class="details">', "\n";
<a name="line259"></a>                            if ($textTag) {
<a name="line260"></a>                                echo $this->_processInlineTags($textTag);
<a name="line261"></a>                            }
<a name="line262"></a>                            $this->_processTags($method->tags());
<a name="line263"></a>                            echo "</div>\n\n";
<a name="line264"></a>                            echo "<hr>\n\n";
<a name="line265"></a>                        }
<a name="line266"></a>					}
<a name="line267"></a>
<a name="line268"></a>					$this->_output = ob_get_contents();
<a name="line269"></a>					ob_end_clean();
<a name="line270"></a>					
<a name="line271"></a>					$this->_write($package->asPath().'/'.strtolower($class->name()).'.html', $class->name(), TRUE);
<a name="line272"></a>				}
<a name="line273"></a>			}
<a name="line274"></a>		}
<a name="line275"></a>    }
<a name="line276"></a>
<a name="line277"></a>	/** Build the class hierarchy tree which is placed at the top of the page.
<a name="line278"></a>	 *
<a name="line279"></a>	 * @param RootDoc rootDoc The root doc
<a name="line280"></a>	 * @param ClassDoc class Class to generate tree for
<a name="line281"></a>	 * @param int depth Depth of recursion
<a name="line282"></a>	 * @return mixed[]
<a name="line283"></a>	 */
<a name="line284"></a>	function _buildTree(&$rootDoc, &$class, $depth = NULL)
<a name="line285"></a>    {
<a name="line286"></a>		if ($depth === NULL) {
<a name="line287"></a>			$start = TRUE;
<a name="line288"></a>			$depth = 0;
<a name="line289"></a>		} else {
<a name="line290"></a>			$start = FALSE;
<a name="line291"></a>		}
<a name="line292"></a>		$output = '';
<a name="line293"></a>		$undefinedClass = FALSE;
<a name="line294"></a>		if ($class->superclass()) {
<a name="line295"></a>			$superclass =& $rootDoc->classNamed($class->superclass());
<a name="line296"></a>			if ($superclass) {
<a name="line297"></a>				$result = $this->_buildTree($rootDoc, $superclass, $depth);
<a name="line298"></a>				$output .= $result[0];
<a name="line299"></a>				$depth = ++$result[1];
<a name="line300"></a>			} else {
<a name="line301"></a>				$output .= $class->superclass().'<br>';
<a name="line302"></a>				$output .= str_repeat('   ', $depth).' └─';
<a name="line303"></a>				$depth++;
<a name="line304"></a>				$undefinedClass = TRUE;
<a name="line305"></a>			}
<a name="line306"></a>		}
<a name="line307"></a>		if ($depth > 0 && !$undefinedClass) {
<a name="line308"></a>			$output .= str_repeat('   ', $depth).' └─';
<a name="line309"></a>		}
<a name="line310"></a>		if ($start) {
<a name="line311"></a>			$output .= '<strong>'.$class->name().'</strong><br />';
<a name="line312"></a>		} else {
<a name="line313"></a>			$output .= '<a href="'.str_repeat('../', $this->_depth).$class->asPath().'">'.$class->name().'</a><br>';
<a name="line314"></a>		}
<a name="line315"></a>		return array($output, $depth);
<a name="line316"></a>	}
<a name="line317"></a>	
<a name="line318"></a>	/** Display the inherited fields of an element. This method calls itself
<a name="line319"></a>	 * recursively if the element has a parent class.
<a name="line320"></a>	 *
<a name="line321"></a>	 * @param ProgramElementDoc element
<a name="line322"></a>	 * @param RootDoc rootDoc
<a name="line323"></a>	 * @param PackageDoc package
<a name="line324"></a>	 */
<a name="line325"></a>	function inheritFields(&$element, &$rootDoc, &$package)
<a name="line326"></a>    {
<a name="line327"></a>		$fields =& $element->fields();
<a name="line328"></a>		if ($fields) {
<a name="line329"></a>            ksort($fields);
<a name="line330"></a>			$num = count($fields); $foo = 0;
<a name="line331"></a>			echo '<table class="inherit">', "\n";
<a name="line332"></a>			echo '<tr><th colspan="2">Fields inherited from ', $element->qualifiedName(), "</th></tr>\n";
<a name="line333"></a>			echo '<tr><td>';
<a name="line334"></a>			foreach($fields as $field) {
<a name="line335"></a>				echo '<a href="', str_repeat('../', $this->_depth), $field->asPath(), '">', $field->name(), '</a>';
<a name="line336"></a>				if (++$foo < $num) {
<a name="line337"></a>					echo ', ';
<a name="line338"></a>				}
<a name="line339"></a>			}
<a name="line340"></a>			echo '</td></tr>';
<a name="line341"></a>			echo "</table>\n\n";
<a name="line342"></a>			if ($element->superclass()) {
<a name="line343"></a>                $superclass =& $rootDoc->classNamed($element->superclass());
<a name="line344"></a>                if ($superclass) {
<a name="line345"></a>                    $this->inheritFields($superclass, $rootDoc, $package);
<a name="line346"></a>                }
<a name="line347"></a>			}
<a name="line348"></a>		}
<a name="line349"></a>	}
<a name="line350"></a>	
<a name="line351"></a>	/** Display the inherited methods of an element. This method calls itself
<a name="line352"></a>	 * recursively if the element has a parent class.
<a name="line353"></a>	 *
<a name="line354"></a>	 * @param ProgramElementDoc element
<a name="line355"></a>	 * @param RootDoc rootDoc
<a name="line356"></a>	 * @param PackageDoc package
<a name="line357"></a>	 */
<a name="line358"></a>	function inheritMethods(&$element, &$rootDoc, &$package)
<a name="line359"></a>    {
<a name="line360"></a>		$methods =& $element->methods();
<a name="line361"></a>		if ($methods) {
<a name="line362"></a>            ksort($methods);
<a name="line363"></a>			$num = count($methods); $foo = 0;
<a name="line364"></a>			echo '<table class="inherit">', "\n";
<a name="line365"></a>			echo '<tr><th colspan="2">Methods inherited from ', $element->qualifiedName(), "</th></tr>\n";
<a name="line366"></a>			echo '<tr><td>';
<a name="line367"></a>			foreach($methods as $method) {
<a name="line368"></a>				echo '<a href="', str_repeat('../', $this->_depth), $method->asPath(), '">', $method->name(), '</a>';
<a name="line369"></a>				if (++$foo < $num) {
<a name="line370"></a>					echo ', ';
<a name="line371"></a>				}
<a name="line372"></a>			}
<a name="line373"></a>			echo '</td></tr>';
<a name="line374"></a>			echo "</table>\n\n";
<a name="line375"></a>			if ($element->superclass()) {
<a name="line376"></a>                $superclass =& $rootDoc->classNamed($element->superclass());
<a name="line377"></a>                if ($superclass) {
<a name="line378"></a>                    $this->inheritMethods($superclass, $rootDoc, $package);
<a name="line379"></a>                }
<a name="line380"></a>			}
<a name="line381"></a>		}
<a name="line382"></a>	}
<a name="line383"></a>
<a name="line384"></a>}
<a name="line385"></a>
<a name="line386"></a>?>
<a name="line387"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../../overview-files.html">Files</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../todo-list.html">Todo</a></li>
<li><a href="../../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../../index.html" target="_top">Frames</a>
<a href="../../../source/doclets/standard/classwriter.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>